#pragma once

#include "AboutBox.h"

namespace Softphone_VC_NET {

	using namespace System;
	using namespace System::Diagnostics;
	using namespace System::Text;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;
	
	using namespace Ozeki::Media;
	using namespace Ozeki::Media::MediaHandlers;
	using namespace Ozeki::Network::Nat;
	using namespace Ozeki::VoIP;
	using namespace Ozeki::VoIP::Media;
	using namespace Ozeki::VoIP::SDK;
	using namespace Ozeki::Common;
	using namespace Ozeki::Network;

	/// <summary>
	/// Summary for WindowMain
	/// </summary>
	public ref class WindowMain : public System::Windows::Forms::Form
	{
	public:
		WindowMain(void)
		{
			InitializeComponent();
			//
			//TODO: Add the constructor code here
			//
		}

	protected:
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		~WindowMain()
		{
			if (components)
			{
				delete components;
			}
		}
	private: System::Windows::Forms::Button^  buttonHangUp;
	protected: 
	private: System::Windows::Forms::ToolStripMenuItem^  Tsmi_HelpPage;
	private: System::Windows::Forms::Button^  button10;
	private: System::Windows::Forms::Panel^  panel2;
	private: System::Windows::Forms::Panel^  panel1;
	private: System::Windows::Forms::Label^  labelIdentifier;
	private: System::Windows::Forms::Label^  labelRegStatus;
	private: System::Windows::Forms::Label^  labelDialingNumber;
	private: System::Windows::Forms::Label^  labelCallStateInfo;
	private: System::Windows::Forms::Button^  buttonPickUp;
	private: System::Windows::Forms::Button^  button11;
	private: System::Windows::Forms::Button^  button12;
	private: System::Windows::Forms::Button^  button7;
	private: System::Windows::Forms::Button^  button8;
	private: System::Windows::Forms::Button^  button9;
	private: System::Windows::Forms::Button^  button4;
	private: System::Windows::Forms::Button^  button5;
	private: System::Windows::Forms::Button^  button6;
	private: System::Windows::Forms::Button^  button3;
	private: System::Windows::Forms::Button^  button2;
	private: System::Windows::Forms::Button^  button1;
	private: System::Windows::Forms::ToolStripMenuItem^  Tsmi_About;
	private: System::Windows::Forms::MenuStrip^  menuStrip1;
	private: System::Windows::Forms::ToolStripMenuItem^  fileToolStripMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  exitToolStripMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  Tsmi_Help;
	private: System::Windows::Forms::ToolStripStatusLabel^  Tssl_Ozeki;
	private: System::Windows::Forms::StatusStrip^  statusStrip1;
	private: System::Windows::Forms::ToolStripStatusLabel^  toolStripStatusLabel2;

	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>
		System::ComponentModel::Container ^components;

#pragma region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			System::ComponentModel::ComponentResourceManager^  resources = (gcnew System::ComponentModel::ComponentResourceManager(WindowMain::typeid));
			this->buttonHangUp = (gcnew System::Windows::Forms::Button());
			this->Tsmi_HelpPage = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->button10 = (gcnew System::Windows::Forms::Button());
			this->panel2 = (gcnew System::Windows::Forms::Panel());
			this->panel1 = (gcnew System::Windows::Forms::Panel());
			this->labelIdentifier = (gcnew System::Windows::Forms::Label());
			this->labelRegStatus = (gcnew System::Windows::Forms::Label());
			this->labelDialingNumber = (gcnew System::Windows::Forms::Label());
			this->labelCallStateInfo = (gcnew System::Windows::Forms::Label());
			this->buttonPickUp = (gcnew System::Windows::Forms::Button());
			this->button11 = (gcnew System::Windows::Forms::Button());
			this->button12 = (gcnew System::Windows::Forms::Button());
			this->button7 = (gcnew System::Windows::Forms::Button());
			this->button8 = (gcnew System::Windows::Forms::Button());
			this->button9 = (gcnew System::Windows::Forms::Button());
			this->button4 = (gcnew System::Windows::Forms::Button());
			this->button5 = (gcnew System::Windows::Forms::Button());
			this->button6 = (gcnew System::Windows::Forms::Button());
			this->button3 = (gcnew System::Windows::Forms::Button());
			this->button2 = (gcnew System::Windows::Forms::Button());
			this->button1 = (gcnew System::Windows::Forms::Button());
			this->Tsmi_About = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuStrip1 = (gcnew System::Windows::Forms::MenuStrip());
			this->fileToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->exitToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->Tsmi_Help = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->Tssl_Ozeki = (gcnew System::Windows::Forms::ToolStripStatusLabel());
			this->statusStrip1 = (gcnew System::Windows::Forms::StatusStrip());
			this->toolStripStatusLabel2 = (gcnew System::Windows::Forms::ToolStripStatusLabel());
			this->panel2->SuspendLayout();
			this->panel1->SuspendLayout();
			this->menuStrip1->SuspendLayout();
			this->statusStrip1->SuspendLayout();
			this->SuspendLayout();
			// 
			// buttonHangUp
			// 
			this->buttonHangUp->Location = System::Drawing::Point(161, 167);
			this->buttonHangUp->Name = L"buttonHangUp";
			this->buttonHangUp->Size = System::Drawing::Size(63, 35);
			this->buttonHangUp->TabIndex = 17;
			this->buttonHangUp->Text = L"Hang Up";
			this->buttonHangUp->UseVisualStyleBackColor = true;
			this->buttonHangUp->Click += gcnew System::EventHandler(this, &WindowMain::buttonHangUp_Click);
			// 
			// Tsmi_HelpPage
			// 
			this->Tsmi_HelpPage->Name = L"Tsmi_HelpPage";
			this->Tsmi_HelpPage->Size = System::Drawing::Size(250, 24);
			this->Tsmi_HelpPage->Text = L"Open online documentation";
			this->Tsmi_HelpPage->Click += gcnew System::EventHandler(this, &WindowMain::Tsmi_HelpPage_Click);
			// 
			// button10
			// 
			this->button10->Location = System::Drawing::Point(23, 331);
			this->button10->Name = L"button10";
			this->button10->Size = System::Drawing::Size(63, 35);
			this->button10->TabIndex = 15;
			this->button10->Tag = L"10";
			this->button10->Text = L"*";
			this->button10->UseVisualStyleBackColor = true;
			this->button10->Click += gcnew System::EventHandler(this, &WindowMain::btn_Click);
			// 
			// panel2
			// 
			this->panel2->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
			this->panel2->Controls->Add(this->panel1);
			this->panel2->Controls->Add(this->buttonHangUp);
			this->panel2->Controls->Add(this->buttonPickUp);
			this->panel2->Controls->Add(this->button10);
			this->panel2->Controls->Add(this->button11);
			this->panel2->Controls->Add(this->button12);
			this->panel2->Controls->Add(this->button7);
			this->panel2->Controls->Add(this->button8);
			this->panel2->Controls->Add(this->button9);
			this->panel2->Controls->Add(this->button4);
			this->panel2->Controls->Add(this->button5);
			this->panel2->Controls->Add(this->button6);
			this->panel2->Controls->Add(this->button3);
			this->panel2->Controls->Add(this->button2);
			this->panel2->Controls->Add(this->button1);
			this->panel2->Location = System::Drawing::Point(12, 30);
			this->panel2->Name = L"panel2";
			this->panel2->Size = System::Drawing::Size(245, 385);
			this->panel2->TabIndex = 25;
			// 
			// panel1
			// 
			this->panel1->BackColor = System::Drawing::Color::White;
			this->panel1->Controls->Add(this->labelIdentifier);
			this->panel1->Controls->Add(this->labelRegStatus);
			this->panel1->Controls->Add(this->labelDialingNumber);
			this->panel1->Controls->Add(this->labelCallStateInfo);
			this->panel1->Location = System::Drawing::Point(20, 17);
			this->panel1->Name = L"panel1";
			this->panel1->Size = System::Drawing::Size(203, 130);
			this->panel1->TabIndex = 18;
			// 
			// labelIdentifier
			// 
			this->labelIdentifier->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 11.25F, System::Drawing::FontStyle::Regular, 
				System::Drawing::GraphicsUnit::Point, static_cast<System::Byte>(238)));
			this->labelIdentifier->Location = System::Drawing::Point(121, 6);
			this->labelIdentifier->Name = L"labelIdentifier";
			this->labelIdentifier->Size = System::Drawing::Size(79, 18);
			this->labelIdentifier->TabIndex = 3;
			this->labelIdentifier->Text = L"Identifier";
			this->labelIdentifier->TextAlign = System::Drawing::ContentAlignment::TopRight;
			// 
			// labelRegStatus
			// 
			this->labelRegStatus->AutoSize = true;
			this->labelRegStatus->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 11.25F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->labelRegStatus->Location = System::Drawing::Point(3, 6);
			this->labelRegStatus->Name = L"labelRegStatus";
			this->labelRegStatus->Size = System::Drawing::Size(50, 18);
			this->labelRegStatus->TabIndex = 2;
			this->labelRegStatus->Text = L"Offline";
			// 
			// labelDialingNumber
			// 
			this->labelDialingNumber->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 11.25F, System::Drawing::FontStyle::Regular, 
				System::Drawing::GraphicsUnit::Point, static_cast<System::Byte>(238)));
			this->labelDialingNumber->Location = System::Drawing::Point(9, 80);
			this->labelDialingNumber->Name = L"labelDialingNumber";
			this->labelDialingNumber->Size = System::Drawing::Size(180, 22);
			this->labelDialingNumber->TabIndex = 1;
			this->labelDialingNumber->TextAlign = System::Drawing::ContentAlignment::TopCenter;
			// 
			// labelCallStateInfo
			// 
			this->labelCallStateInfo->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 12, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->labelCallStateInfo->Location = System::Drawing::Point(5, 44);
			this->labelCallStateInfo->Name = L"labelCallStateInfo";
			this->labelCallStateInfo->Size = System::Drawing::Size(195, 24);
			this->labelCallStateInfo->TabIndex = 0;
			this->labelCallStateInfo->Text = L"No connection";
			this->labelCallStateInfo->TextAlign = System::Drawing::ContentAlignment::TopCenter;
			// 
			// buttonPickUp
			// 
			this->buttonPickUp->Location = System::Drawing::Point(23, 167);
			this->buttonPickUp->Name = L"buttonPickUp";
			this->buttonPickUp->Size = System::Drawing::Size(63, 35);
			this->buttonPickUp->TabIndex = 16;
			this->buttonPickUp->Text = L"Pick Up";
			this->buttonPickUp->UseVisualStyleBackColor = true;
			this->buttonPickUp->Click += gcnew System::EventHandler(this, &WindowMain::buttonPickUp_Click);
			// 
			// button11
			// 
			this->button11->Location = System::Drawing::Point(92, 331);
			this->button11->Name = L"button11";
			this->button11->Size = System::Drawing::Size(63, 35);
			this->button11->TabIndex = 14;
			this->button11->Tag = L"0";
			this->button11->Text = L"0/+";
			this->button11->UseVisualStyleBackColor = true;
			this->button11->Click += gcnew System::EventHandler(this, &WindowMain::btn_Click);
			// 
			// button12
			// 
			this->button12->Location = System::Drawing::Point(161, 331);
			this->button12->Name = L"button12";
			this->button12->Size = System::Drawing::Size(63, 35);
			this->button12->TabIndex = 13;
			this->button12->Tag = L"11";
			this->button12->Text = L"#";
			this->button12->UseVisualStyleBackColor = true;
			this->button12->Click += gcnew System::EventHandler(this, &WindowMain::btn_Click);
			// 
			// button7
			// 
			this->button7->Location = System::Drawing::Point(23, 290);
			this->button7->Name = L"button7";
			this->button7->Size = System::Drawing::Size(63, 35);
			this->button7->TabIndex = 12;
			this->button7->Tag = L"7";
			this->button7->Text = L"7";
			this->button7->UseVisualStyleBackColor = true;
			this->button7->Click += gcnew System::EventHandler(this, &WindowMain::btn_Click);
			// 
			// button8
			// 
			this->button8->Location = System::Drawing::Point(92, 290);
			this->button8->Name = L"button8";
			this->button8->Size = System::Drawing::Size(63, 35);
			this->button8->TabIndex = 11;
			this->button8->Tag = L"8";
			this->button8->Text = L"8";
			this->button8->UseVisualStyleBackColor = true;
			this->button8->Click += gcnew System::EventHandler(this, &WindowMain::btn_Click);
			// 
			// button9
			// 
			this->button9->Location = System::Drawing::Point(161, 290);
			this->button9->Name = L"button9";
			this->button9->Size = System::Drawing::Size(63, 35);
			this->button9->TabIndex = 10;
			this->button9->Tag = L"9";
			this->button9->Text = L"9";
			this->button9->UseVisualStyleBackColor = true;
			this->button9->Click += gcnew System::EventHandler(this, &WindowMain::btn_Click);
			// 
			// button4
			// 
			this->button4->Location = System::Drawing::Point(23, 249);
			this->button4->Name = L"button4";
			this->button4->Size = System::Drawing::Size(63, 35);
			this->button4->TabIndex = 9;
			this->button4->Tag = L"4";
			this->button4->Text = L"4";
			this->button4->UseVisualStyleBackColor = true;
			this->button4->Click += gcnew System::EventHandler(this, &WindowMain::btn_Click);
			// 
			// button5
			// 
			this->button5->Location = System::Drawing::Point(92, 249);
			this->button5->Name = L"button5";
			this->button5->Size = System::Drawing::Size(63, 35);
			this->button5->TabIndex = 8;
			this->button5->Tag = L"5";
			this->button5->Text = L"5";
			this->button5->UseVisualStyleBackColor = true;
			this->button5->Click += gcnew System::EventHandler(this, &WindowMain::btn_Click);
			// 
			// button6
			// 
			this->button6->Location = System::Drawing::Point(161, 249);
			this->button6->Name = L"button6";
			this->button6->Size = System::Drawing::Size(63, 35);
			this->button6->TabIndex = 7;
			this->button6->Tag = L"6";
			this->button6->Text = L"6";
			this->button6->UseVisualStyleBackColor = true;
			this->button6->Click += gcnew System::EventHandler(this, &WindowMain::btn_Click);
			// 
			// button3
			// 
			this->button3->Location = System::Drawing::Point(161, 208);
			this->button3->Name = L"button3";
			this->button3->Size = System::Drawing::Size(63, 35);
			this->button3->TabIndex = 6;
			this->button3->Tag = L"3";
			this->button3->Text = L"3";
			this->button3->UseVisualStyleBackColor = true;
			this->button3->Click += gcnew System::EventHandler(this, &WindowMain::btn_Click);
			// 
			// button2
			// 
			this->button2->Location = System::Drawing::Point(92, 208);
			this->button2->Name = L"button2";
			this->button2->Size = System::Drawing::Size(63, 35);
			this->button2->TabIndex = 5;
			this->button2->Tag = L"2";
			this->button2->Text = L"2";
			this->button2->UseVisualStyleBackColor = true;
			this->button2->Click += gcnew System::EventHandler(this, &WindowMain::btn_Click);
			// 
			// button1
			// 
			this->button1->Location = System::Drawing::Point(23, 208);
			this->button1->Name = L"button1";
			this->button1->Size = System::Drawing::Size(63, 35);
			this->button1->TabIndex = 4;
			this->button1->Tag = L"1";
			this->button1->Text = L"1";
			this->button1->UseVisualStyleBackColor = true;
			this->button1->Click += gcnew System::EventHandler(this, &WindowMain::btn_Click);
			this->button1->MouseDown += gcnew System::Windows::Forms::MouseEventHandler(this, &WindowMain::btn_MouseDown);
			this->button1->MouseUp += gcnew System::Windows::Forms::MouseEventHandler(this, &WindowMain::btn_MouseUp);
			// 
			// Tsmi_About
			// 
			this->Tsmi_About->Name = L"Tsmi_About";
			this->Tsmi_About->Size = System::Drawing::Size(250, 24);
			this->Tsmi_About->Text = L"About";
			this->Tsmi_About->Click += gcnew System::EventHandler(this, &WindowMain::Tsmi_About_Click);
			// 
			// menuStrip1
			// 
			this->menuStrip1->Font = (gcnew System::Drawing::Font(L"Segoe UI", 10));
			this->menuStrip1->Items->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(2) {this->fileToolStripMenuItem, 
				this->Tsmi_Help});
			this->menuStrip1->Location = System::Drawing::Point(0, 0);
			this->menuStrip1->Name = L"menuStrip1";
			this->menuStrip1->Size = System::Drawing::Size(268, 27);
			this->menuStrip1->TabIndex = 23;
			this->menuStrip1->Text = L"menuStrip1";
			// 
			// fileToolStripMenuItem
			// 
			this->fileToolStripMenuItem->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(1) {this->exitToolStripMenuItem});
			this->fileToolStripMenuItem->Name = L"fileToolStripMenuItem";
			this->fileToolStripMenuItem->Size = System::Drawing::Size(41, 23);
			this->fileToolStripMenuItem->Text = L"File";
			// 
			// exitToolStripMenuItem
			// 
			this->exitToolStripMenuItem->Name = L"exitToolStripMenuItem";
			this->exitToolStripMenuItem->Size = System::Drawing::Size(99, 24);
			this->exitToolStripMenuItem->Text = L"Exit";
			this->exitToolStripMenuItem->Click += gcnew System::EventHandler(this, &WindowMain::exitToolStripMenuItem_Click);
			// 
			// Tsmi_Help
			// 
			this->Tsmi_Help->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(2) {this->Tsmi_HelpPage, 
				this->Tsmi_About});
			this->Tsmi_Help->Name = L"Tsmi_Help";
			this->Tsmi_Help->Size = System::Drawing::Size(49, 23);
			this->Tsmi_Help->Text = L"Help";
			// 
			// Tssl_Ozeki
			// 
			this->Tssl_Ozeki->Name = L"Tssl_Ozeki";
			this->Tssl_Ozeki->Size = System::Drawing::Size(81, 17);
			this->Tssl_Ozeki->Text = L"Ozeki product";
			// 
			// statusStrip1
			// 
			this->statusStrip1->Items->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(2) {this->toolStripStatusLabel2, 
				this->Tssl_Ozeki});
			this->statusStrip1->Location = System::Drawing::Point(0, 415);
			this->statusStrip1->Name = L"statusStrip1";
			this->statusStrip1->Size = System::Drawing::Size(268, 22);
			this->statusStrip1->TabIndex = 24;
			this->statusStrip1->Text = L"statusStrip1";
			// 
			// toolStripStatusLabel2
			// 
			this->toolStripStatusLabel2->AutoSize = false;
			this->toolStripStatusLabel2->Name = L"toolStripStatusLabel2";
			this->toolStripStatusLabel2->Size = System::Drawing::Size(172, 17);
			this->toolStripStatusLabel2->Spring = true;
			// 
			// WindowMain
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(268, 437);
			this->Controls->Add(this->panel2);
			this->Controls->Add(this->menuStrip1);
			this->Controls->Add(this->statusStrip1);
			this->FormBorderStyle = System::Windows::Forms::FormBorderStyle::FixedSingle;
			this->Icon = (cli::safe_cast<System::Drawing::Icon^  >(resources->GetObject(L"$this.Icon")));
			this->MaximizeBox = false;
			this->Name = L"WindowMain";
			this->Text = L"Ozeki C++.NET Softphone";
			this->Load += gcnew System::EventHandler(this, &WindowMain::WindowMain_Load);
			this->panel2->ResumeLayout(false);
			this->panel1->ResumeLayout(false);
			this->panel1->PerformLayout();
			this->menuStrip1->ResumeLayout(false);
			this->menuStrip1->PerformLayout();
			this->statusStrip1->ResumeLayout(false);
			this->statusStrip1->PerformLayout();
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion
	private: 

#pragma region Fields

		ISoftPhone ^m_softPhone;
		IPhoneLine ^m_phoneLine;
		PhoneLineState m_phoneLineInformation;
		IPhoneCall ^m_call;
		Microphone ^m_microphone;
		Speaker    ^m_speaker;
		MediaConnector ^m_connector;
		PhoneCallAudioSender ^m_mediaSender;
		PhoneCallAudioReceiver ^m_mediaReceiver;
		bool					m_incomingCall;

#pragma endregion

#pragma region Delegates

		delegate void SetIncomingCallDelegate(IPhoneCall ^phoneCall);
		delegate void SetPhoneLineStateDelegate(PhoneLineState phoneLineState);
		delegate void SetTextDelegate(String ^text);

#pragma endregion 

#pragma region Methods

#pragma region GUI_Event_Handlers

		void WindowMain_Load(System::Object ^sender, System::EventArgs ^e);
		void exitToolStripMenuItem_Click(System::Object ^sender, System::EventArgs ^e);
		void Tsmi_HelpPage_Click(System::Object ^sender, System::EventArgs ^e);
		void Tsmi_About_Click(System::Object ^sender, System::EventArgs ^e);
		void buttonPickUp_Click(System::Object ^sender, System::EventArgs ^e);
		void buttonHangUp_Click(System::Object ^sender, System::EventArgs ^e);
		void btn_Click(System::Object ^sender, System::EventArgs ^e);
		void btn_MouseUp(System::Object ^sender, System::Windows::Forms::MouseEventArgs ^e);
		void btn_MouseDown(System::Object ^sender, System::Windows::Forms::MouseEventArgs ^e);

#pragma endregion 

		void InitMediaHandlers();
		void InitializeSoftphone();
		void softPhone_IncomingCall(Object ^sender, VoIPEventArgs<IPhoneCall^> ^e);
		void phoneLine_PhoneLineInformation(Object ^sender, VoIPEventArgs<PhoneLineState> ^e);
		void WireUpCallEvents();
		void WireDownCallEvents();
		void call_DtmfReceived(Object ^sender, VoIPEventArgs<OzTuple<VoIPMediaType, DtmfSignal^>^> ^e);
		void call_CallStateChanged(Object ^sender, VoIPEventArgs<CallState> ^e);
		void call_ErrorOccurred(Object ^sender, VoIPEventArgs<CallError> ^e);
		void SetIncomingCall(IPhoneCall ^phoneCall);
		void SetPhoneLineState(PhoneLineState phoneLineState);
		void SetCallStateInfo(String ^text);
		void SetDialingNumber(String ^text);

#pragma endregion

};
}
